﻿using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Text;
using System.Net;

namespace MyLibrary
{
    public class MyHttpClient
    {

        public string SendHttpRequest(string h1, string h2, string url, string proxy = null, bool useProxy = false, string contentType = "application/json")
        //public string SendHttpRequest(string h1, string h2, string url)
        {

            
            var request = new HttpRequestMessage(HttpMethod.Post, url);
            var uri = request.RequestUri; 
            var mySP = ServicePointManager.FindServicePoint(uri);
            mySP.Expect100Continue = false; // Удалить заголовок  expect: '100-continue'

            var headers = ParseHeaders(h1);
            foreach (var header in headers)
            {
                request.Headers.TryAddWithoutValidation(header.Key, header.Value);
            }
            


            request.Content = new StringContent(h2, Encoding.UTF8, contentType);

            var handler = new HttpClientHandler();
            handler.Proxy = new System.Net.WebProxy(proxy);
            handler.UseProxy = useProxy;
            var client = new HttpClient(handler);

            client.DefaultRequestHeaders.ExpectContinue = false;

            var response = client.SendAsync(request).Result;
            var result = response.Content.ReadAsStringAsync().Result;

            return result;
        }

        static Dictionary<string, string> ParseHeaders(string headerString)
        {
            var headers = new Dictionary<string, string>();
            var lines = headerString.Split(new[] { '\n' }, StringSplitOptions.RemoveEmptyEntries);
            foreach (var line in lines)
            {
                var parts = line.Split(new[] { ':' }, 2);
                var key = parts[0].Trim();
                var value = parts[1].Trim();
                headers[key] = value;
            }
            return headers;
        }
    }
}

